%define name lkstutils
%define version 2.2.1
%define release 11AX

%define prefix /usr

%define withlkcd 0

%{?_without_lkcd: %{expand: %%define withlkcd 0}}
%{?_with_lkcd: %{expand: %%define withlkcd 1}}

%ifarch ia64
%define withlkcd 0
%endif

%if %{withlkcd}
%define lkcdconfig --enable-lkcd
%else
%define lkcdconfig --disable-lkcd
%endif

Name: %{name}
Summary: Linux Kernel State Tracer (LKST) Utilities
Version: %{version}
Release: %{release}
Group: Applications/System
Source: lkst-%{version}.tar.gz
Source1: lkstlogtools.tar.gz
License: GPL
URL: http://sourceforge.net/projects/lkst/
BuildRoot: %{_tmppath}/%{name}-root/
BuildPreReq: autoconf
PreReq: coreutils
Patch0: lkstutils-2.2-build.patch
Patch1: lkstutils-logformat.patch
Patch2: lkstutils-rpm.patch
Patch3: lkstlogtools-kernel24.patch
Patch4: lkstlogtools-ksyms.patch
Patch5: lkstlogtools-mktemp.patch
Patch6: lkstlogtools-makemask.patch
Patch7: lkstutils-lkstm.patch

%if %{withlkcd}
BuildPreReq: lkcdutils >= 4.1
Requires: lkcdutils >= 4.1
%endif

%description
The lkstutils package contains user tools for
Linux Kernel State Tracer (LKST). It includes
the following tools.

- lkstbuf         Control kernel event buffer in LKST.
- lksteh          Control event-handler in LKST. 
- lkst            Control status of LKST.
- logformat.pl    display LKST trace data
- lkstm           Control maskset in LKST.
- lkstlogd        LKST logging utility.
- lkstlogger      Tells LKST that a specified event has occurred.

Authors:
--------
   K.SERIZAWA <serizawa@sdl.hitachi.co.jp>
   T.NAKAMURA <tetsu@crl.hitachi.co.jp>
   K.HATASAKI <keisukeh@crl.hitachi.co.jp>
   Y.GOTO <y-goto@jp.fujitsu.com> 
   T.INDOH <indou.takao@jp.fujitsu.com>
   M.HIRAMATSU <hiramatu@sdl.hitachi.co.jp>

%prep
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%setup -n lkst-%{version}
%patch0 -p1
%patch2 -p1
%patch7 -p1

pushd lkstutils
%patch1 -p1
popd

tar xfz %{SOURCE1}
%patch5 -p1
%patch6 -p1
pushd lkstlogtools
patch -p0 < %{PATCH3}
patch -p0 < %{PATCH4}
popd

%build
pushd lkstutils
autoconf
./configure --prefix=%{prefix} \
	    --with-ksrc=/usr/src/linux-2.4 \
            --with-kbin=/usr/src/linux-2.4 \
	    --mandir=%{_mandir} \
	    %{lkcdconfig}
make
popd

pushd lkstaddons
autoconf
./configure --prefix=%{prefix} \
	    --with-ksrc=/usr/src/linux-2.4 \
            --with-kbin=/usr/src/linux-2.4 \
	    --mandir=%{_mandir} \
	    %{lkcdconfig}
popd

pushd lkstlogtools/src
make lkstla lkstlogdiv
popd

%install
mkdir -p $RPM_BUILD_ROOT%{prefix}/sbin
mkdir -p $RPM_BUILD_ROOT%{prefix}/share/sial/lcrash
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
pushd lkstutils
make LKSTLOGD_LOGDIR=$RPM_BUILD_ROOT/var/log/lkst \
     prefix=$RPM_BUILD_ROOT%{prefix} \
     mandir=$RPM_BUILD_ROOT%{_mandir} \
     MKDEV= \
     install
#mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
#install -m 644 redhat/lkstlogd $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m 755 redhat/lkst.init $RPM_BUILD_ROOT%{_initrddir}/lkst
install -m 755 redhat/lkstlogd.init $RPM_BUILD_ROOT%{_initrddir}/lkstlogd
popd

pushd lkstlogtools
mkdir -p $RPM_BUILD_ROOT%{prefix}/sbin
install -m 755 bin/lkstla $RPM_BUILD_ROOT%{prefix}/sbin/lkstla
install -m 755 bin/lkstlogdiv $RPM_BUILD_ROOT%{prefix}/sbin/lkstlogdiv
install -m 755 scripts/lkst_plot_dist $RPM_BUILD_ROOT%{prefix}/sbin/lkst_plot_dist
install -m 755 scripts/lkst_plot_log $RPM_BUILD_ROOT%{prefix}/sbin/lkst_plot_log
install -m 755 scripts/lkst_plot_stat $RPM_BUILD_ROOT%{prefix}/sbin/lkst_plot_stat
install -m 755 scripts/lkst_fmt_sysinfo $RPM_BUILD_ROOT%{prefix}/sbin/lkst_fmt_sysinfo
install -m 755 scripts/lkst_make_mask $RPM_BUILD_ROOT%{prefix}/sbin/lkst_make_mask
install -m 755 scripts/lkst_plot_sysinfo $RPM_BUILD_ROOT%{prefix}/sbin/lkst_plot_sysinfo
popd

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
[ -c /dev/lkst ] || mknod --mode=600 /dev/lkst c 231 0

%preun
if [ "$1" = 0 ]; then
	service lkst stop > /dev/null 2>&1
	chkconfig --del lkst
	service lkstlogd stop > /dev/null 2>&1
	chkconfig --del lkstlogd
fi

%postun
if [ "$1" = 0 ]; then
	rm -f /dev/lkst
fi

%files
%defattr(-, root, root)
%doc lkstutils/redhat/*
#%config(missingok) %{_sysconfdir}/lkstlogd
%{_initrddir}/lkst
%{_initrddir}/lkstlogd
%{prefix}/sbin/lkstbuf
%{prefix}/sbin/lksteh
%{prefix}/sbin/lkst
%{prefix}/sbin/lkstm
%{prefix}/sbin/lkstlogd
%{prefix}/sbin/lkstlogger
%{_mandir}/man8/*
%{_mandir}/man1/*
%dir /var/log/lkst
%if %{withlkcd}
%{prefix}/share/sial/lcrash/lkstdump.sial
%{prefix}/share/sial/lcrash/lkstdumplib.so
%endif
%{prefix}/sbin/lkstla
%{prefix}/sbin/lkstlogdiv
%{prefix}/sbin/lkst_plot_dist
%{prefix}/sbin/lkst_plot_log
%{prefix}/sbin/lkst_plot_stat
%{prefix}/sbin/lkst_fmt_sysinfo
%{prefix}/sbin/lkst_make_mask
%{prefix}/sbin/lkst_plot_sysinfo

%changelog
* Sun Feb 13 2005 Yasuma Takeda <yasuma@miraclelinux.com> 2.2.1-11AX
- update to latest version

* Mon Feb  7 2005 Yasuma Takeda <yasuma@miraclelinux.com> 2.2.1-8AX
- refine spec file to build lkstutils and lkstlogtools

* Thu Jan 12 2005 Yasuma Takeda <yasuma@miraclelinux.com> 2.2.1-5AX
- update lkstlogtools

* Fri Dec 24 2004 Yasuma Takeda <yasuma@miraclelinux.com> 2.2.1-1AX
- add lkstlogtools support

* Mon Nov 08 2004 Yasuma Takeda <yasuma@miraclelinux.com> 2.2-2AX
- removed logformat.pl

* Thu Nov 04 2004 Yasuma Takeda <yasuma@miraclelinux.com> 2.2-1.1AX
- update to LKST-2.2

* Fri May 21 2004 Yasuma Takeda <yasuma@miraclelinux.com> 2.0.1-1.3AX
- add PreReq tag 

* Wed Apr 07 2004 Tatsuo Ito <tito@miraclelinux.com> 2.0.1-1.2AX
- apply patch from hitach for Asianux
- change configure option
- change post, preun, and postun section in spec

* Wed Aug 27 2003 HITACHI,LTD., FUJITSU,LTD.
- add --with-lkcd/--without-lkcd option. 

* Wed Jul 30 2003 HITACHI,LTD., FUJITSU,LTD.
- fix Copyright tag to License tag.

* Thu May  8 2003 HITACHI,LTD., FUJITSU,LTD.
- Add Requires.
- Don't make lkstdump on ia64

* Mon Feb 17 2003 HITACHI,LTD., FUJITSU,LTD.
- Fix build-requirements.

* Mon Feb 17 2003 HITACHI,LTD., FUJITSU,LTD.
- Upgrade against for v1.4

* Mon Nov 25 2002 HITACHI,LTD., FUJITSU,LTD.
- Fixed some bugs.

* Fri Aug 30 2002 HITACHI,LTD., FUJITSU,LTD.
- Release v1.3
  Performance improvement of Kernel Hooks.
  Modify default maskset.
  Support CSV format by lkstbuf command.
  Add and modify APIs for event-handler.
  Add config to delete hooks on inline func.
  Add script to make /dev/lkst.
  Fix some bugs.

* Mon May 13 2002 Masami HIRAMATSU <hiramatu@sdl.hitachi.co.jp>
- customize from original.(rel 2)
